#define WIFI_NAME "Wifi adınız"
#define WIFI_PASSWORD "Wifi şifreniz"      // Burada Esp8266 kartınız wifi bağlantısı için gerekli bilgileri giriyoruz.
#define DEVICE_ID 1         // Burada Device ID dediği şey bizim RemoteMe sayfasında oluşturduğumuz device numarasıdır. Bu sayede aynı anda telefonunuzfa farklı kartları da yönetme imkanı sağlamaktadır.
#define DEVICE_NAME "lamba_kod"       // Device name olarak da yine bizim kendi belirlediğimiz isim burada olacaktır.
#define TOKEN "********************"     // Burada  RemoteMe sayfasının bize vermiş olduğu "Key" yani Token yazacaktır.


// Buraya kadarki yerlerde her hangi bir değişiklik yapmamıza gerek yok zaten RemoteMe'den kod alma işlemlerini yaptığınız taktirde buralar yazılı şekilde gelecektir.


#include <RemoteMe.h>
#include <RemoteMeSocketConnector.h>      // Burada gerekli kütüphanelerimiz var sizde bu isimleri kütüphane yöneticisine yazarak indirebilirsiniz.
#include <ESP8266WiFi.h>                       

uint8_t isik = 5;    // Burada tetikleme yapacağımız röle kartımızın IN pinine bağlı olan pinimizi belirtiyoruz.



RemoteMe& remoteMe = RemoteMe::getInstance(TOKEN, DEVICE_ID);    // Burada yine bize verilen kodda bulunan RemoteMe token ve Devicenizin doğru olduğunu kontrol ediyor.

inline void setMasa_lamba(boolean a) {remoteMe.getVariables()->setBoolean("masa_lamba", a); } // Burada masa lamba adı altında açtığımız Device içerisine atanacak değişkenimizi belirliyoruz. Burası da zaten RemoteMe tarafından veriliyor.

void onMasa_lambaChange(boolean a) {
                                            // Burada onMasa_lambaChange içerisinde bulunan değişkenin google asistan ile tetiklenmesini sağlıyoruz yani HIGH yada LOW olma durumunu belirlediğimiz kodumuzu bunun içerisine yazıyoruz.
    digitalWrite(isik,a?HIGH:LOW);
}

/* buraya kadar geldiğimizde şunu sizlerle paylaşmak isterim burada gördüğünüz "a" değerini RemoteMe sayfasından kod çekme adımlarınızı yaptığımız zaman "b" olarak yazacaktır. 
 Eğerki bir tane lamba kontrolü yapacaksanız bunun her hangi bir sorunu olmayacaktır. Birden fazla aracı kontrol etmeye başladığımız anda buradaki isimlerin önemi olacaktır. RemoteMe sayfası her Veriable'la "b" değeri verecektir.
*/

void setup() {

  WiFi.begin(WIFI_NAME, WIFI_PASSWORD);

  while (WiFi.status() != WL_CONNECTED) {                          // Setup kısmına geldiğimizde burada Wifi bağlantı kodlarımız bulunuyor. Bu kodları yine RemoteMe hazır bir şekilde vermektedir.
    delay(100);
  }

  remoteMe.getVariables()->observeBoolean("masa_lamba" ,onMasa_lambaChange);

  remoteMe.setConnector(new RemoteMeSocketConnector());
  remoteMe.sendRegisterDeviceMessage(DEVICE_NAME);
  pinMode(isik, OUTPUT);                            // Tetikleme yapacağımız pinimizin durumunu burada pinMode komutumuz ile belirliyoruz.
  digitalWrite(isik, LOW);                    // bu komutumuzu yazmamız sebebi ise biz açıl komutu vermeden lambamızın yanmasını önlemek.
  
}


void loop() {
  remoteMe.loop();         //Loop kısmında sadece RemoteMe çalıştırmamız yeterli olacaktır.   Bu kodu da zaten RemoteMe hazırda verecektir.
}
